From 020366b48d85b264f7d3799a3835ad3e8a898593 Mon Sep 17 00:00:00 2001
From: Baochen qiang <bqiang@codeaurora.org>
Date: Thu, 6 Aug 2020 18:21:43 +0800
Subject: [PATCH 11/17] ath11k: add support for QCA6490 hw2.0

Signed-off-by: Baochen qiang <bqiang@codeaurora.org>
---
 drivers/net/wireless/ath/ath11k/ce.c     |  3 ++-
 drivers/net/wireless/ath/ath11k/core.c   | 31 +++++++++++++++++++++---
 drivers/net/wireless/ath/ath11k/core.h   |  3 ++-
 drivers/net/wireless/ath/ath11k/dp_rx.c  |  3 ++-
 drivers/net/wireless/ath/ath11k/hal_rx.c |  6 +++--
 drivers/net/wireless/ath/ath11k/pci.c    | 12 ++++++++-
 6 files changed, 49 insertions(+), 9 deletions(-)

diff --git a/drivers/net/wireless/ath/ath11k/ce.c b/drivers/net/wireless/ath/ath11k/ce.c
index 456db5c8fc39..d7ad31795edc 100644
--- a/drivers/net/wireless/ath/ath11k/ce.c
+++ b/drivers/net/wireless/ath/ath11k/ce.c
@@ -754,7 +754,8 @@ int ath11k_ce_attr_attach(struct ath11k_base *ab)
 		break;
 	case ATH11K_HW_QCA6290:
 	case ATH11K_HW_QCA6390:
-	case ATH11K_HW_QCA6490:
+	case ATH11K_HW_QCA6490_HW11:
+	case ATH11K_HW_QCA6490_HW20:
 		ab->ce.host_ce_config = host_ce_config_wlan_qca6x90;
 		ab->ce.ce_count = 9;
 		break;
diff --git a/drivers/net/wireless/ath/ath11k/core.c b/drivers/net/wireless/ath/ath11k/core.c
index 0bdc9d435d29..11cbffc11315 100644
--- a/drivers/net/wireless/ath/ath11k/core.c
+++ b/drivers/net/wireless/ath/ath11k/core.c
@@ -69,8 +69,8 @@ static const struct ath11k_hw_params ath11k_hw_params_list[] = {
 			HAL_HASH_ROUTING_RING_SW4 << 21,
 	},
 	{
-		.name = "qca6490",
-		.dev_id = ATH11K_HW_QCA6490,
+		.name = "qca6490 hw1.1",
+		.dev_id = ATH11K_HW_QCA6490_HW11,
 		.fw = {
 			.dir = "QCA6490/hw1.1",
 		},
@@ -91,6 +91,30 @@ static const struct ath11k_hw_params ath11k_hw_params_list[] = {
 			HAL_HASH_ROUTING_RING_SW2 << 20 |\
 			HAL_HASH_ROUTING_RING_SW3 << 24 |\
 			HAL_HASH_ROUTING_RING_SW4 << 28,
+        },
+	{
+		.name = "qca6490 hw2.0",
+		.dev_id = ATH11K_HW_QCA6490_HW20,
+		.fw = {
+			.dir = "QCA6490/hw2.0",
+		},
+		.internal_sleep_clock = true,
+		.single_pdev_only = true,
+		.hw_ops = &ath11k_hw_ops_qca6x90,
+		.srng_params = &ath11k_hw_srng_qca6390,
+		.misc_caps = MISC_CAPS_HOST2FW_RXBUF_RING |
+			MISC_CAPS_TCL_0_ONLY,
+		.rxdma1_enable = false,
+		.num_rxmda_per_pdev = 2,
+		.vdev_start_delay = true,
+		.ring_hmap = HAL_HASH_ROUTING_RING_SW1 << 0 |\
+			HAL_HASH_ROUTING_RING_SW2 << 4 |\
+			HAL_HASH_ROUTING_RING_SW3 << 8 |\
+			HAL_HASH_ROUTING_RING_SW4 << 12 |\
+			HAL_HASH_ROUTING_RING_SW1 << 16 |\
+			HAL_HASH_ROUTING_RING_SW2 << 20 |\
+			HAL_HASH_ROUTING_RING_SW3 << 24 |\
+			HAL_HASH_ROUTING_RING_SW4 << 28,
         }
 };
 
@@ -987,7 +1011,8 @@ int ath11k_core_pre_init(struct ath11k_base *ab)
 		ab->regs = &qca6390_regs;
 		ab->hw_values = &qca6x90_values;
 		break;
-	case ATH11K_HW_QCA6490:
+	case ATH11K_HW_QCA6490_HW11:
+	case ATH11K_HW_QCA6490_HW20:
 		ab->regs = &qca6490_regs;
 		ab->hw_values = &qca6x90_values;
 		ath11k_override_hal_srng_config(ab);
diff --git a/drivers/net/wireless/ath/ath11k/core.h b/drivers/net/wireless/ath/ath11k/core.h
index ca8745001710..59b20a5be5de 100644
--- a/drivers/net/wireless/ath/ath11k/core.h
+++ b/drivers/net/wireless/ath/ath11k/core.h
@@ -97,7 +97,8 @@ enum ath11k_hw_rev {
 	ATH11K_HW_IPQ8074,
 	ATH11K_HW_QCA6290,
 	ATH11K_HW_QCA6390,
-	ATH11K_HW_QCA6490,
+	ATH11K_HW_QCA6490_HW11,
+	ATH11K_HW_QCA6490_HW20,
 };
 
 enum ath11k_firmware_mode {
diff --git a/drivers/net/wireless/ath/ath11k/dp_rx.c b/drivers/net/wireless/ath/ath11k/dp_rx.c
index 89870b5f17ac..403fd3f1bbfd 100644
--- a/drivers/net/wireless/ath/ath11k/dp_rx.c
+++ b/drivers/net/wireless/ath/ath11k/dp_rx.c
@@ -5519,7 +5519,8 @@ int ath11k_dp_rx_ops_init(struct ath11k_base *ab){
 	case ATH11K_HW_QCA6390:
 		ab->dp.rx_ops = &ath11k_dp_rx_ops;
 		break;
-	case ATH11K_HW_QCA6490:
+	case ATH11K_HW_QCA6490_HW11:
+	case ATH11K_HW_QCA6490_HW20:
 		ab->dp.rx_ops = &ath11k_dp_rx_ops_qca6490
 		;break;
 	default:
diff --git a/drivers/net/wireless/ath/ath11k/hal_rx.c b/drivers/net/wireless/ath/ath11k/hal_rx.c
index 4cd66b9b8da7..6e38ab20d7b9 100644
--- a/drivers/net/wireless/ath/ath11k/hal_rx.c
+++ b/drivers/net/wireless/ath/ath11k/hal_rx.c
@@ -886,7 +886,8 @@ static u16 ath11k_hal_rx_mpdu_info_get_peerid(struct ath11k_base *ab, u8* tlv_da
 						__le32_to_cpu(mpdu_info->info0));
 			}
 			break;
-		case ATH11K_HW_QCA6490:
+		case ATH11K_HW_QCA6490_HW11:
+		case ATH11K_HW_QCA6490_HW20:
 			{
 				struct hal_rx_mpdu_info_qca6490 *mpdu_info =
 					(struct hal_rx_mpdu_info_qca6490*)tlv_data;
@@ -1301,7 +1302,8 @@ int ath11k_hal_rx_ops_init(struct ath11k_base* ab)
         case ATH11K_HW_QCA6390:
                 ab->hal.rx_ops = &ath11k_hal_rx_ops;
                 break;
-        case ATH11K_HW_QCA6490:
+	case ATH11K_HW_QCA6490_HW11:
+	case ATH11K_HW_QCA6490_HW20:
                 ab->hal.rx_ops = &ath11k_hal_rx_ops_qca6490;
                 break;
         default:
diff --git a/drivers/net/wireless/ath/ath11k/pci.c b/drivers/net/wireless/ath/ath11k/pci.c
index 0264df99f830..213731c804c8 100644
--- a/drivers/net/wireless/ath/ath11k/pci.c
+++ b/drivers/net/wireless/ath/ath11k/pci.c
@@ -14,6 +14,10 @@
 #include "debug.h"
 #include "coredump.h"
 
+#define TCSR_SOC_HW_VERSION		0x0224
+#define TCSR_SOC_HW_VERSION_MAJOR_MASK	GENMASK(16, 8)
+#define TCSR_SOC_HW_VERSION_MINOR_MASK	GENMASK(7, 0)
+
 const char *irq_name[ATH11K_IRQ_NUM_MAX] = {
 	"bhi",
 	"mhi-er0",
@@ -1360,6 +1364,7 @@ static int ath11k_pci_probe(struct pci_dev *pdev,
 	struct ath11k_pci *ab_pci;
 	enum ath11k_hw_rev hw_rev;
 	int ret;
+	u32 val;
 
 	switch (pci_dev->device) {
 	case QCA6290_DEVICE_ID:
@@ -1368,7 +1373,12 @@ static int ath11k_pci_probe(struct pci_dev *pdev,
 		hw_rev = ATH11K_HW_QCA6390;
 		break;
 	case QCA6490_DEVICE_ID:
-		hw_rev = ATH11K_HW_QCA6490;
+		val = ath11k_pci_read32(ab, TCSR_SOC_HW_VERSION);
+		ath11k_dbg(ab, ATH11K_DBG_PCI, "tcsr_soc_hw_version 0x%x\n", val);
+		if (FIELD_GET(TCSR_SOC_HW_VERSION_MAJOR_MASK, val) == 1)
+			hw_rev = ATH11K_HW_QCA6490_HW11;
+		else
+			hw_rev = ATH11K_HW_QCA6490_HW20;
 		break;
 	default:
 		dev_err(&pdev->dev, "Unknown PCI device found: 0x%x\n",
-- 
2.17.1

